#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    int grupe[4];
    //       o            a           b           ab
    cin >> grupe[0] >> grupe[1] >> grupe[2] >> grupe[3];
    int sumaDostupna = grupe[0]+grupe[1]+grupe[2]+grupe[3];

    bool moze=true;
    int ispis[n][4];
    for(int i=0;i<n;++i){
        string tmpc;
        int tmpi;
        cin >>tmpc>>tmpi;
        if(tmpc=="O")
        {
            if(grupe[0]>=tmpi){
                grupe[0]-=tmpi;
                ispis[i][0]=tmpi;
                ispis[i][1]=0;
                ispis[i][2]=0;
                ispis[i][3]=0;
            }
            else{
                moze=false;
            }

        }
        else if(tmpc=="A")
        {
            if(grupe[1]>=tmpi){
                grupe[1]-=tmpi;
                ispis[i][0]=0;
                ispis[i][1]=tmpi;
                ispis[i][2]=0;
                ispis[i][3]=0;
            } else if(grupe[0]+grupe[1]>=tmpi){

                ispis[i][0]=tmpi-grupe[1];
                ispis[i][1]=grupe[1];
                ispis[i][2]=0;
                ispis[i][3]=0;
                grupe[0]-=grupe[1]+tmpi;
                grupe[1]=0;
            }
            else{
                moze=false;
            }
        }
        else if(tmpc=="B")
        {
            if(grupe[2]>=tmpi){
                grupe[2]-=tmpi;
                ispis[i][0]=0;
                ispis[i][1]=0;
                ispis[i][2]=tmpi;
                ispis[i][3]=0;
            } else if(grupe[0]+grupe[2]>=tmpi){

                ispis[i][0]=tmpi-grupe[2];
                ispis[i][1]=0;
                ispis[i][2]=grupe[2];
                ispis[i][3]=0;
                grupe[0]-=grupe[2]+tmpi;
                grupe[2]=0;
            }
            else{
                moze=false;
            }
        }
        else
        {
            if(grupe[3]>=tmpi){
                grupe[3]-=tmpi;
                ispis[i][0]=0;
                ispis[i][1]=0;
                ispis[i][2]=0;
                ispis[i][3]=tmpi;
            }
            else if(grupe[2]+grupe[3]>=tmpi){
                ispis[i][0]=0;
                ispis[i][1]=0;
                ispis[i][2]=tmpi-grupe[3];
                ispis[i][3]=grupe[3];
                grupe[2]-=grupe[3]+tmpi;
                grupe[3]=0;
            }else if(grupe[1]+grupe[3]>=tmpi){
                ispis[i][0]=0;
                ispis[i][1]=tmpi-grupe[3];
                ispis[i][2]=0;
                ispis[i][3]=grupe[3];
                grupe[1]-=grupe[3]+tmpi;
                grupe[3]=0;
            }else if(grupe[0]+grupe[3]>=tmpi){
                ispis[i][0]=tmpi-grupe[3];
                ispis[i][1]=0;
                ispis[i][2]=0;
                ispis[i][3]=grupe[3];
                grupe[0]-=grupe[3]+tmpi;
                grupe[3]=0;
            }
            else{
                moze=false;
            }
        }
    }

    if(moze){
        cout << "moguce" << endl;
        for(int i=0;i<n;++i){
            cout << ispis[i][0] << " " << ispis[i][1] << " " << ispis[i][2] << " " << ispis[i][3] << endl;
        }
    }
    else{
        printf("nemoguce");
    }
    return 0;
}